// priority: 10


ServerEvents.recipes(event => {

  //Slabs To Blocks
  event.forEachRecipe({type: 'minecraft:crafting_shaped', output: '#minecraft:slabs'}, r => {
    let ingredients = r.originalRecipeIngredients 
    let output = r.originalRecipeResult    
    event.shaped(ingredients[0], ['S', 'S'], { S: output })
  })

  //Smelting

  event.smelting('1x stoneopolis:void_nugget', 'stoneopolis:void_chunk').id('stoneopolis:void_nugget_smelt')
  event.smelting('1x minecraft:glass', 'stoneopolis:concrete_dust').id('stoneopolis:glass')
  event.blasting('1x ae2:certus_quartz_crystal', 'ae2:certus_quartz_dust').id('stoneopolis:certus_quartz')
  event.blasting('1x minecraft:torch', "minecraft:stick").id("minecraft:torch_furnace")
  event.blasting('1x caveopolis:stone_torch', "caveopolis:stone_stick").id("caveopolis:stone_torch_furnace")
  event.blasting('1x alltheores:tin_ingot', "alltheores:tin_dust").id("stoneopolis:tin_ingot_blasting").experience(0.15)

  //Campfire

  event.campfireCooking('1x minecraft:torch', "minecraft:stick").id("minecraft:torch")
  event.campfireCooking('1x caveopolis:stone_torch', "caveopolis:stone_stick").id("caveopolis:stone_torch")
  event.campfireCooking('1x caveopolis:gray_colored_stone', "minecraft:stone").id("stoneopolis:gray_colored_stone_campfire")

  //SPRAY CAN STAGED CRAFTING!!!!

  //Misc

  event.shaped(`minecraft:end_stone`, [' F ', 'FSF', ' F '], {F: 'opolisutilities:ender_pearl_fragment', S: 'minecraft:stone'}).id(`stoneopolis:end_stone`)
  event.shaped(`minecraft:chorus_flower`, [' F ', 'FSF', ' F '], {F: 'opolisutilities:ender_pearl_fragment', S: 'caveopolis:black_colored_sapling'}).id(`stoneopolis:chorus_flower`)
  event.shaped(`minecraft:chorus_flower`, [' F ', 'FSF', ' F '], {F: 'opolisutilities:ender_pearl_fragment', S: 'minecraft:chorus_fruit'}).id(`stoneopolis:chorus_flower_chorus`)
  event.shaped(`6x stoneopolis:void_lead_nugget`, ['VVV', 'PSP', 'VVV'], {V: 'stoneopolis:void_nugget', S: 'caveopolis:purple_colored_sapling', P:'minecraft:purpur_block'}).id(`stoneopolis:void_lead_nugget_crafting`)

  event.shaped(`1x alltheores:lead_ore`, ['SLS', 'LSL', 'SLS'], {L: 'alltheores:lead_ingot', S: 'minecraft:stone'}).id(`stoneopolis:lead_ore`)
  event.shaped(`1x minecraft:crimson_nylium`, ['W', 'N'], {N:'minecraft:netherrack', W: 'minecraft:nether_wart'}).id(`stoneopolis:crimson_nylium`)

  //Shaped Recipes	
  event.shaped('1x minecraft:stone', ['SS','SS'], {S: "strainers:stone_pebble"}).id('stoneopolis:stone')
  event.shaped('1x minecraft:feather', ['  S','SSS', 'S  '], {S: "#forge:string"}).id('stoneopolis:feather')
	
  event.shaped('1x javd:portal_block', [' S ','SIS',' S '], {S: "stoneopolis:void_chunk", I: "stoneopolis:void_ingot"}).id('javd:portal_block')
	
  event.shaped('1x caveopolis:gray_colored_sapling', [' S ','STS',' T '], {S: stone, T: "caveopolis:stone_stick"}).id('stoneopolis:gray_colored_sapling')
  event.shaped(`1x caveopolis:black_colored_sapling`, [' O ', 'OSO', ' O '], {O: 'stoneopolis:bottled_void', S: '#caveopolis:colored_saplings'}).id(`stoneopolis:black_colored_sapling`)
  event.shaped('1x caveopolis:magenta_colored_sapling', ['FFF', ' S ', 'GGG'], {G: "minecraft:warped_fungus", F: "minecraft:crimson_fungus", S:'#caveopolis:colored_saplings'}).id('stoneopolis:magenta_colored_sapling')    
  event.shaped('1x caveopolis:pink_colored_sapling', ['F G', 'FSG', 'F G'], {G: "minecraft:warped_fungus", F: "minecraft:crimson_fungus", S:'#caveopolis:colored_saplings'}).id('stoneopolis:pink_colored_sapling')    
  event.shaped('1x caveopolis:brown_colored_sapling', [' D ', 'DSD', ' D '], {D: "minecraft:dirt", S:'#caveopolis:colored_saplings'}).id('stoneopolis:brown_colored_sapling')    
  event.shaped(`1x caveopolis:orange_colored_sapling`, [' O ', 'OSO', ' O '], {O: 'alltheores:copper_dust', S: '#caveopolis:colored_saplings'}).id(`stoneopolis:orange_colored_sapling`)
  event.shaped(`1x caveopolis:light_gray_colored_sapling`, [' O ', 'OSO', ' O '], {O: 'alltheores:tin_dust', S: '#caveopolis:colored_saplings'}).id(`stoneopolis:light_gray_colored_sapling`)
  event.shaped(`1x caveopolis:yellow_colored_sapling`, [' O ', 'OSO', ' O '], {O: 'minecraft:sand', S: '#caveopolis:colored_saplings'}).id(`stoneopolis:yellow_colored_sapling`)
  event.shaped(`1x caveopolis:red_colored_sapling`, [' O ', 'OSO', ' O '], {O: 'bloodmagic:blankslate', S: '#caveopolis:colored_saplings'}).id(`stoneopolis:red_colored_sapling`)
  event.shaped(`1x caveopolis:green_colored_sapling`, [' O ', 'OSO', ' O '], {O: 'minecraft:ender_pearl', S: '#caveopolis:colored_saplings'}).id(`stoneopolis:green_colored_sapling`)
  event.shaped(`1x caveopolis:lime_colored_sapling`, [' O ', 'OSO', ' O '], {O: 'minecraft:slime_ball', S: '#caveopolis:colored_saplings'}).id(`stoneopolis:lime_colored_sapling`)
  event.shaped(`1x caveopolis:light_blue_colored_sapling`, [' O ', 'OSO', ' O '], {O: 'geode_plus:wrappist_shard', S: '#caveopolis:colored_saplings'}).id(`stoneopolis:light_blue_colored_sapling`)
  event.shaped(`1x caveopolis:purple_colored_sapling`, [' O ', 'OSO', ' O '], {O: 'ae2:fluix_crystal', S: '#caveopolis:colored_saplings'}).id(`stoneopolis:purple_colored_sapling`)
  event.shaped(`1x caveopolis:cyan_colored_sapling`, [' O ', 'OSO', ' O '], {O: 'minecraft:clay_ball', S: '#caveopolis:colored_saplings'}).id(`stoneopolis:cyan_colored_sapling`)
  event.shaped(`1x caveopolis:white_colored_sapling`, [' O ', 'OSO', ' O '], {O: 'minecraft:bone_meal', S: '#caveopolis:colored_saplings'}).id(`stoneopolis:white_colored_sapling`)
  event.shaped(`1x caveopolis:blue_colored_sapling`, [' O ', 'OSO', ' O '], {O: 'minecraft:lapis_lazuli', S: '#caveopolis:colored_saplings'}).id(`stoneopolis:blue_colored_sapling`)
  
  
  
  event.shaped('1x caveopolis:colored_caves_portal', ['CCC','FBF', 'CCC'], {C:'#caveopolis:colored_stone', F:'stoneopolis:nether_star_fragment', B:'industrialforegoing:machine_frame_supreme'}).id('caveopolis:colored_caves_portal')

	event.shaped('1x minecraft:stone_pickaxe', ['PPP',' S ',' S '], {S: stick, P: stone}).id('stoneopolis:stone_pickaxe')
  event.shaped('1x minecraft:netherite_ingot', ['DGD','GQG','DGD'], {G: gold_ingot, Q: "minecraft:echo_shard", D: "alltheores:netherite_dust"}).id('stoneopolis:netherite_ingot_stoneopolis')
  event.shaped('1x minecraft:wither_skeleton_skull', ['FF','FF'], {F: 'stoneopolis:nether_skull_fragment'}).id('stoneopolis:wither_skeleton_skull')
  event.shaped('1x minecraft:netherite_ingot', ['NNN', 'NNN', 'NNN'], {N: `stoneopolis:netherite_nugget`}).id(`stoneopolis:netherite_ingot_from_nugget`)
  event.shaped('1x minecraft:nether_star', ['NNN', 'NNN', 'NNN'], {N: `stoneopolis:nether_star_fragment`}).id(`stoneopolis:nether_star`)
  event.shaped('1x woodenhopper:wooden_hopper', ['PWP', 'PWP', ' P '], {P: "#minecraft:planks", W: "#minecraft:logs"})
  event.shaped('1x minecraft:hopper', ['PWP', 'PWP', ' P '], {P: iron_ingot, W: "#minecraft:logs"})
 
  event.shaped(`1x strainers:eroding_salt_mulch`, ['GDA', 'LML', 'ADG'], {M:'strainers:mulch', L: 'minecraft:charcoal', A: 'minecraft:andesite', D: "minecraft:diorite", G:"minecraft:granite"}).id(`strainers:eroding_salt_mulch`)
  event.shaped('1x strainers:summoning_block', ['VVV', 'CLC', 'CCC'], {C: bronze_ingot, L: 'bloodmagic:life_essence_bucket', V: 'stoneopolis:void_ingot'}).id('strainers:summoning_block')
  event.shaped('1x strainers:reinforced_input_upgrade', ['SRS', 'RUR', 'SRS'], {R: "opolisutilities:resource_generator_2", S: '#forge:stone', U: 'strainers:sturdy_input_upgrade'}).id("strainers:upgrades/reinforced/reinforced_input_upgrade")


  event.shaped('4x functionalstorage:compacting_framed_drawer', ['1V1','VIV','1V1'], {1: 'functionalstorage:framed_4', V: 'stoneopolis:void_nugget', I: 'stoneopolis:void_ingot'}).id('functionalstorage:compacting_framed_drawer') 
  event.shaped('4x functionalstorage:framed_simple_compacting_drawer', ['1V1','VIV','1V1'], {1: 'functionalstorage:framed_1', V: 'stoneopolis:void_nugget', I: 'stoneopolis:void_ingot'}).id('functionalstorage:framed_simple_compacting_drawer') 
  event.shaped('1x functionalstorage:framed_storage_controller', ['4V4','VJV','4V4'], {4: 'functionalstorage:compacting_framed_drawer', V: 'stoneopolis:void_ingot', J: 'javd:portal_block'}).id('functionalstorage:framed_storage_controller') 
  event.shaped('1x functionalstorage:framed_controller_extension', ['4V4','VJV','4V4'], {4: 'functionalstorage:framed_simple_compacting_drawer', V: 'stoneopolis:void_ingot', J: 'javd:portal_block'}).id('functionalstorage:framed_controller_extension') 
  event.shaped('1x functionalstorage:linking_tool', ['VVV','FIF','VVV'], {I: 'stoneopolis:void_ingot', V: 'stoneopolis:void_nugget', F: '#functionalstorage:drawer'}).id('functionalstorage:linking_tool') 
  event.shaped('1x functionalstorage:configuration_tool', ['VVV','IFI','VVV'], {I: 'stoneopolis:void_ingot', V: 'stoneopolis:void_nugget', F: '#functionalstorage:drawer'}).id('functionalstorage:configuration_tool') 
    
  event.shaped('2x bhc:canister', ['III','TPT','III'], {I: iron_ingot, T: 'lavamotron:thermal_shard', P:'stoneopolis:pig_iron'}).id('bhc:canister') 
  event.shaped('1x bhc:red_heart_canister', ['BCB','BHB','BCB'], {B: bronze_ingot, C: 'bhc:canister', H:'bhc:red_heart'}).id('bhc:red_heart_canister') 
  event.shaped('1x bhc:blade_of_vitality', ['  P', ' P ', 'S  '], {S: stick, P: "industrialforegoing:plastic"}).id('bhc:blade_of_vitality')

  event.shaped('8x stoneopolis:rainbow_bricks', ['SSS', 'SRS', 'SSS'], {S: "minecraft:stone_bricks", R: "stoneopolis:rainbow_color_core"}).id(`stoneopolis:rainbow_bricks`)
  event.shaped('2x stoneopolis:pig_iron', [' I ','ILI',' I '], {I: iron_ingot, L: 'bloodmagic:weakbloodorb'}).id('stoneopolis:pig_iron') 
  event.shaped('1x stoneopolis:void_string', ['L', 'L', 'L'], {L: 'caveopolis:black_colored_leaves'}).id('stoneopolis:void_string')
  event.shaped('1x stoneopolis:void_dirt', ['AA', 'AA'], {A: 'stoneopolis:void_apple'}).id('stoneopolis:void_dirt_apples')
  event.shaped('1x stoneopolis:void_dirt', ['LLL', 'L L', 'LLL'], {L: 'caveopolis:black_colored_leaves'}).id('stoneopolis:void_dirt_leaves')
  event.shaped('3x stoneopolis:geode_fragment', ['FSF', 'SFS', 'FSF'], {F: "opolisutilities:ender_pearl_fragment", S: "strainers:stone_pebble"}).id('stoneopolis:geode_fragment')
  event.shaped('1x stoneopolis:empty_budding_stone', ['FSF', 'SFS', 'FSF'], {F: "stoneopolis:geode_fragment", S: stone}).id('stoneopolis:empty_budding_stone')
  event.shaped('1x stoneopolis:cluster_template', [' F ', 'FFF', 'FFF'], {F: "stoneopolis:geode_fragment"}).id('stoneopolis:cluster_template')
  event.shaped('1x stoneopolis:stone_charm', ['SSS', 'SVS', 'SSS'], {S: stone, V:"stoneopolis:void_ingot"}).id('stoneopolis:stone_charm')
  event.shaped('1x stoneopolis:budding_charm', ['BBB', 'BCB', 'BBB'], {B: "bloodmagic:blankrune", C: "stoneopolis:cluster_template"}).id(`stoneopolis:budding_charm`)
  event.shaped('1x stoneopolis:cluster_grower', ['  C', ' S ', 'S  '], {S:stick, C: 'stoneopolis:cluster_template'}).id('stoneopolis:cluster_grower')
  event.shaped('1x stoneopolis:netherite_bone', ['NBN'], {B: "minecraft:bone", N: "#forge:nuggets/netherite"}).id('stoneopolis:netherite_bone')    
  event.shaped(`1x stoneopolis:void_ingot`, ['NNN', 'NNN', 'NNN'], {N: `stoneopolis:void_nugget`}).id(`stoneopolis:void_ingot`)
  event.shaped('1x stoneopolis:fertile_stone', ['PPP','PSP','PPP'], {S: 'caveopolis:gray_colored_sapling', P: "strainers:stone_pebble"}).id('stoneopolis:fertile_stone')
  event.shaped('1x stoneopolis:fire_stick', ['  F', ' S ', 'F  '], {F: "stoneopolis:lava_fragment", S: stick}).id('stoneopolis:fire_stick')
  event.shaped('1x stoneopolis:lapistone_alloy', ['NNN', 'NNN', 'NNN'], {N: `stoneopolis:lapistone_nugget`}).id(`stoneopolis:lapistone_alloy`)
  event.shaped('1x stoneopolis:gear_box', ['BCB', 'CGC', 'BCB'], {G: gold_gear, C: 'immersiveengineering:reinforced_crate', B: bronze_gear}).id(`stoneopolis:gear_box`)
  event.shaped('1x stoneopolis:bright_color_core', ['ABC','DME', 'FGH'], {A:'caveopolis:cyan_colored_stone', B:'caveopolis:lime_colored_stone', C:'caveopolis:yellow_colored_stone', D:'caveopolis:light_blue_colored_stone', E:'caveopolis:magenta_colored_stone', F:'caveopolis:pink_colored_stone', G:'caveopolis:orange_colored_stone', H:'caveopolis:white_colored_stone', M: 'stoneopolis:blank_color_core'}).id('stoneopolis:bright_color_core')
  event.shaped('1x stoneopolis:dark_color_core', ['ABC','DME', 'FGH'], {A:'caveopolis:black_colored_stone', B:'caveopolis:gray_colored_stone', C:'caveopolis:light_gray_colored_stone', D:'caveopolis:red_colored_stone', E:'caveopolis:green_colored_stone', F:'caveopolis:brown_colored_stone', G:'caveopolis:blue_colored_stone', H:'caveopolis:purple_colored_stone', M: 'stoneopolis:blank_color_core'}).id('stoneopolis:dark_color_core')

  event.shaped('1x opolisutilities:drying_table', ['LSL', 'LSL', 'L L'], {L: stick, S:'stoneopolis:void_string'}).id('opolisutilities:drying_table')
  event.shaped('1x opolisutilities:resource_generator', ['DDD', 'DCD', 'DDD'], {D: '#caveopolis:black_colored_logs', C: chest}).id('opolisutilities:resource_generator/resource_generator')
  event.shaped('1x opolisutilities:resource_generator_2', ['COC', 'B B', 'COC'], {C: "#forge:cobblestone", B: "minecraft:water_bucket", O:"minecraft:blaze_rod"}).id('opolisutilities:resource_generator_2')
  
  event.shaped('1x immersiveengineering:hammer', ['BBB', ' S ', ' S '], {B: 'minecraft:brick', S: stick}).id('immersiveengineering:crafting/hammer')
  event.shaped(`3x immersiveengineering:cokebrick`, ['CBC', 'SSS', 'CBC'], {C: 'minecraft:clay_ball', S: '#forge:sand', B: bronze_nugget}).id(`immersiveengineering:crafting/cokebrick`)
  event.shaped('8x immersiveengineering:treated_wood_horizontal', ['PPP', 'PBP', 'PPP'], {P: planks, B: 'immersiveengineering:creosote_bucket'}).id('immersiveengineering:stoneopolis_treated_wood_horizontal')
  event.shaped('4x immersiveengineering:rs_engineering', ['IRI', 'RSR', 'IRI'], {R: redstone, I: iron_ingot, S: steel_ingot}).id(`immersiveengineering:crafting/rs_engineering`)
  event.shaped('8x immersiveengineering:fluid_pipe', ['NNN', '   ', 'NNN'], {N: "immersiveengineering:component_iron"}).id(`immersiveengineering:crafting/fluid_pipe`)
  event.shaped('1x immersiveengineering:thermoelectric_generator', ['LLL','TBT', 'LLL'], {L:'stoneopolis:lapistone_alloy', T:'lavamotron:thermal_shard', B:bronze_ingot}).id('immersiveengineering:crafting/thermoelectric_generator')
  event.shaped('1x immersiveengineering:wirecoil_copper', [' C ','CLC', ' C '], {L:'stoneopolis:lapistone_nugget', C:copper_nugget}).id('stoneopolis:wirecoil_copper')
  event.shaped('1x immersiveengineering:mold_plate', ['ISI','S S', 'ISI'], {I:steel_ingot, S: steel_plate }).id('stoneopolis:mold_plate')

  event.shaped('1x ae2:silicon_press', ['III', 'IFI', 'III'], {I: iron_ingot, F:'ae2:fluix_crystal'}).id('stoneopolis:silicon_press')
  event.shaped('1x ae2:logic_processor_press', ['III', 'GSG', 'III'], {I: iron_ingot, G: gold_ingot, S:'ae2:printed_silicon'}).id('stoneopolis:logic_processor_press')
  event.shaped('1x ae2:calculation_processor_press', ['III', 'GSG', 'III'], {I: iron_ingot, G: 'ae2:certus_quartz_crystal', S:'ae2:printed_silicon'}).id('stoneopolis:calculation_processor_press')
  event.shaped('1x ae2:engineering_processor_press', ['III', 'GSG', 'III'], {I: iron_ingot, G: 'geode_plus:wrappist_shard', S:'ae2:printed_silicon'}).id('stoneopolis:engineering_processor_press')
  
  event.shaped('1x bloodmagic:sacrificialdagger', ['V', 'V', 'S'], {V: 'stoneopolis:void_stone', S: stick}).id('bloodmagic:sacrificial_dagger')
  event.shaped(`1x bloodmagic:noderouter`, ['  I', ' S ', 'S  '], {S:'stoneopolis:routing_stick', I: 'stoneopolis:void_ingot'}).id(`bloodmagic:soulforge/node_router`)
  event.shaped(`1x bloodmagic:masterroutingnode`, [' S ', 'BSB', 'MHM'], {B:'bloodmagic:blankslate', S: 'stoneopolis:routing_stick', H: 'woodenhopper:wooden_hopper', M: 'caveopolis:mixed_stone_ingot'}).id(`bloodmagic:soulforge/master_routing_node`)
  event.shaped(`1x bloodmagic:inputroutingnode`, [' S ', ' S ', 'BHB'], {S: 'stoneopolis:routing_stick', B:'bloodmagic:blankslate', H:'woodenhopper:wooden_hopper'}).id(`bloodmagic:soulforge/input_routing_node`)
  event.shaped(`1x bloodmagic:outputroutingnode`, [' S ', ' S ', 'HBH'], {S: 'stoneopolis:routing_stick', B:'bloodmagic:blankslate', H:'woodenhopper:wooden_hopper'}).id(`bloodmagic:soulforge/output_routing_node`)
  event.shaped(`1x bloodmagic:itemroutingnode`, [' S ', ' S ', 'SSS'], {S: 'stoneopolis:routing_stick'}).id(`bloodmagic:soulforge/routing_node`)

  event.custom({"type": "minecraft:crafting_shaped","category": "misc","key": {"a": {"tag": "forge:stone"},"b": {"item": "bloodmagic:reinforcedslate"},
    "c": {"item": "stoneopolis:void_stone"},"d": {"item": "bloodmagic:blankrune"},"e": {"type": "bloodmagic:bloodorb","orb_tier": 1}},
    "pattern": ["aba","cdc","aea"],"result": {"item": "bloodmagic:sacrificerune"},"show_notification": true
  }).id(`bloodmagic:blood_rune_sacrifice`)

  event.custom({"type": "minecraft:crafting_shaped","category": "misc","key": {"a": {"tag": "forge:stone"},"b": {"item": "bloodmagic:reinforcedslate"},
    "c": {"item": "stoneopolis:void_ingot"},"d": {"item": "bloodmagic:blankrune"},"e": {"type": "bloodmagic:bloodorb","orb_tier": 1}},
    "pattern": ["aba","cdc","aea"],"result": {"item": "bloodmagic:selfsacrificerune"},"show_notification": true
  }).id(`bloodmagic:blood_rune_self_sacrifice`)

  event.shaped(`industrialforegoing:machine_frame_pity`, ['LLL', 'PGP', 'LLL'], {G: 'stoneopolis:gear_box', P: steel_plate, L: "#minecraft:logs"}).id(`industrialforegoing:machine_frame_pity`)


  event.shaped('1x lavamotron:lavamotron', ['DDD', 'DBD', 'LLL'], {L: "stoneopolis:lapistone_alloy", D: "minecraft:deepslate", B: "#stoneopolis:buckets"}).id('lavamotron:lavamotron')

  event.shaped(`hostilenetworks:twilight_prediction`, ['ONE', 'PGC', 'ENO'], {O: `hostilenetworks:overworld_prediction`, N: `hostilenetworks:nether_prediction`, E: `hostilenetworks:end_prediction`, P: "minecraft:prismarine_shard", G: "minecraft:ghast_tear", C: "minecraft:chorus_fruit"}).id(`stoneopolis:ultimate_prediction`)

  event.shaped(`extendedcrafting:basic_table`, ['BCB', 'CTC', 'BCB'], {B: `extendedcrafting:basic_component`, C: '#caveopolis:colored_wooden_plank_crafting_tables', T: 'extendedcrafting:ultimate_catalyst'}).id(`extendedcrafting:basic_table`)
  event.shaped(`extendedcrafting:advanced_table`, ['BCB', 'CTC', 'BCB'], {B: `extendedcrafting:advanced_component`, C: '#caveopolis:colored_wooden_plank_crafting_tables', T: 'extendedcrafting:basic_table'}).id(`extendedcrafting:advanced_table`)
  event.shaped(`extendedcrafting:elite_table`, ['BCB', 'CTC', 'BCB'], {B: `extendedcrafting:elite_component`, C: '#caveopolis:colored_wooden_plank_crafting_tables', T: 'extendedcrafting:advanced_table'}).id(`extendedcrafting:elite_table`)
  event.shaped(`extendedcrafting:ultimate_table`, ['BCB', 'CTC', 'BCB'], {B: `extendedcrafting:ultimate_component`, C: '#caveopolis:colored_wooden_plank_crafting_tables', T: 'extendedcrafting:elite_table'}).id(`extendedcrafting:ultimate_table`)
  
  event.shaped(`4x fluxnetworks:flux_dust`, [' N ', 'NSN', ' N '], {S: `stoneopolis:nether_star_fragment`, N: 'alltheores:netherite_dust'}).id(`stoneopolis:flux_dust`)
  event.shaped(`1x fluxnetworks:flux_block`, ['FFF', 'FFF', 'FFF'], {F: `fluxnetworks:flux_dust`}).id(`fluxnetworks:fluxblock`)
  event.shaped(`1x fluxnetworks:flux_plug`, ['W', 'F'], {W: `ae2:wireless_access_point`,F: `fluxnetworks:flux_block`}).id(`fluxnetworks:fluxplug`)
  event.shaped(`1x fluxnetworks:flux_point`, ['W', 'F'], {W: `ae2:wireless_receiver`,F: `fluxnetworks:flux_block`}).id(`fluxnetworks:fluxpoint`)
  
  event.shaped(`1x stoneopolis:canvas_of_nothing`, ['SSS', 'CPC', 'SSS'], {S: stick, C: 'farmersdelight:canvas', P: "stoneopolis:pure_rainbow_color_core"}).id(`stoneopolis:canvas_of_nothing`)
  event.shaped(`1x stoneopolis:dragon_egg_collector`, [' SP', ' SS', 'S  '], {S: stick, P: "stoneopolis:pure_rainbow_color_core"}).id(`stoneopolis:dragon_egg_collector`)
  event.shaped(`1x stoneopolis:ingot_of_duplication`, ['NNN', 'NIN', 'NNN'], {N: "extendedcrafting:the_ultimate_nugget", I: "#forge:ingots"}).id(`stoneopolis:ingot_of_duplication`)
  
  event.shaped(`1x tiab:time_in_a_bottle`, ['GGG', 'RCR', 'LBL'], {B: "minecraft:glass_bottle", R: "stoneopolis:rainbow_color_core", C:"minecraft:clock", G: gold_ingot, L: "minecraft:lapis_lazuli"}).id(`tiab:time_in_a_bottle`)



  //Shapeless Recipes
  event.shapeless(Item.of (`stoneopolis:void_nugget`, 9), [`stoneopolis:void_ingot`]).id(`stoneopolis:void_nugget`)
  event.shapeless(Item.of (`stoneopolis:rainbow_lens`, 1), [`#stoneopolis:lens`, `stoneopolis:rainbow_dye`]).id(`stoneopolis:rainbow_lens`)
  event.shapeless(Item.of ('stoneopolis:lava_fragment', 8), ["lavamotron:thermal_shard"]).id(`stoneopolis:lava_fragments`)
  event.shapeless(Item.of (`stoneopolis:lapistone_nugget`, 9), [`stoneopolis:lapistone_alloy`]).id(`stoneopolis:lapistone_nugget`)
  event.shapeless(Item.of (`stoneopolis:rainbow_color_core`, 1), [`stoneopolis:dark_color_core`, `stoneopolis:bright_color_core`]).id(`stoneopolis:rainbow_color_core`)
  event.shapeless(Item.of (`stoneopolis:nether_star_fragment`, 9), [`minecraft:nether_star`]).id(`stoneopolis:nether_star_frags`)
  event.shapeless(Item.of (`stoneopolis:netherite_nugget`, 9), [`minecraft:netherite_ingot`]).id(`stoneopolis:netherite_nugget_from_ingot`)

  event.shapeless('1x minecraft:clay', ['minecraft:mud', "stoneopolis:concrete_dust"]).id('stoneopolis:clay_block')
  event.shapeless('9x fluxnetworks:flux_dust', ["fluxnetworks:flux_block"]).id('stoneopolis:flux_block_uncraft')
  
  event.shapeless('1x functionalstorage:puller_upgrade', ["functionalstorage:pusher_upgrade"]).id('stoneopolis:puller_upgrade')
  event.shapeless('1x functionalstorage:pusher_upgrade', ["functionalstorage:puller_upgrade"]).id('stoneopolis:pusher_upgrade')

  event.shapeless(Item.of (`immersiveengineering:redstone_acid_bucket`, 1), ["minecraft:bucket", `8x minecraft:redstone` ]).id(`immersiveengineering:crafting/redstone_acid`)


  //Replace Recipes
  event.replaceInput({}, "minecraft:wooden_shovel", "minecraft:stone_shovel")
  event.replaceInput({}, "immersiveengineering:redstone_acid_bucket", 'immersiveengineering:redstone_acid_bucket')

  event.replaceInput({id: "minecraft:diorite"}, "minecraft:quartz", "caveopolis:mixed_stone_nugget")
  event.replaceInput({id: "minecraft:granite"}, "minecraft:quartz", "caveopolis:mixed_stone_nugget")
  event.replaceInput({id: "minecraft:piston"}, iron_ingot, steel_rod)
  event.replaceInput({id: "minecraft:netherite_upgrade_smithing_template"}, "minecraft:netherite_upgrade_smithing_template", "minecraft:netherite_ingot")

  event.replaceInput({id: "strainers:mulch"}, "minecraft:dirt", "opolisutilities:leafy_string")
  event.replaceInput({id: "strainers:purifying_salt_mulch"}, "minecraft:charcoal", "stoneopolis:concrete_dust")
  event.replaceInput({id: "strainers:summoning_block"}, stone, iron_ingot)
  event.replaceInput({id: "strainers:summoning_block"}, "minecraft:hay_block", "bloodmagic:blankslate")
  event.replaceInput({id: "strainers:summoning_block"}, "minecraft:wheat",  "bloodmagic:blankslate")

  event.replaceInput({id: "ae2:network/blocks/crystal_processing_charger"}, "minecraft:copper_ingot", "ae2:certus_quartz_crystal")
  event.replaceInput({id: "ae2:network/blocks/inscribers"}, "minecraft:copper_ingot", "ae2:fluix_crystal")

  event.replaceInput({id: "bloodmagic:blood_altar"}, "minecraft:gold_ingot", "stoneopolis:void_stone")

  event.replaceInput({id: "hostilenetworks:deep_learner"}, "#forge:glass_panes", "stoneopolis:rainbow_lens")
  event.replaceInput({id: "hostilenetworks:framework"}, "minecraft:smooth_stone", "stoneopolis:rainbow_lens")
  event.replaceInput({id: "hostilenetworks:sim_chamber"}, "#forge:glass_panes", "stoneopolis:rainbow_lens")
  event.replaceInput({id: "hostilenetworks:sim_chamber"}, "minecraft:obsidian", "industrialforegoing:machine_frame_supreme")
  event.replaceInput({id: "hostilenetworks:prediction_matrix"}, "minecraft:clay_ball", "stoneopolis:rainbow_dye")

  event.replaceInput({id: "immersiveengineering:crafting/blastbrick"}, "minecraft:magma_block", "minecraft:blaze_powder")
  event.replaceInput({id: "immersiveengineering:crafting/blastbrick"}, "minecraft:nether_brick", "stoneopolis:lapistone_nugget")
  event.replaceInput({id: "immersiveengineering:crafting/conveyor_basic"}, "#forge:leather", steel_nugget)
  event.replaceInput({id: "immersiveengineering:crafting/heavy_engineering"}, "#forge:ingots/electrum", "stoneopolis:lapistone_nugget")
  event.replaceInput({id: "immersiveengineering:crafting/fluid_pump"}, "#forge:plates/iron", "immersiveengineering:component_iron")
  event.replaceInput({id: "immersiveengineering:crafting/windmill"}, "#forge:ingots/iron", steel_ingot)
  event.replaceInput({id: "immersiveengineering:crafting/coil_lv"}, "minecraft:iron_ingot", steel_ingot)
  event.replaceInput({id: "immersiveengineering:crafting/wirecutter"}, "minecraft:iron_ingot",  "stoneopolis:lapistone_alloy")
  event.replaceInput({id: "immersiveengineering:crafting/blueprint_components"}, '#forge:ingots/aluminum',  "stoneopolis:lapistone_alloy")
  event.replaceInput({id: "immersiveengineering:crafting/capacitor_lv"}, "alltheores:lead_plate", 'minecraft:iron_ingot')
  event.replaceInput({id: "immersiveengineering:crafting/capacitor_mv"}, "alltheores:nickel_plate", steel_plate)
  event.replaceInput({id: "immersiveengineering:crafting/capacitor_mv"}, "alltheores:iron_plate", steel_plate)
  event.replaceInput({id: "immersiveengineering:crafting/capacitor_hv"}, "alltheores:aluminum_plate", "immersiveengineering:ingot_hop_graphite")

  event.replaceInput({id: "immersiveengineering:crafting/capacitor_hv"}, "alltheores:aluminum_plate", "immersiveengineering:ingot_hop_graphite")

  event.replaceInput({id: "flopper:recipes/flopper"}, "#forge:ingots/iron", "immersiveengineering:component_iron")

  event.replaceInput({id: "farmersdelight:flint_knife"}, "minecraft:flint", "stoneopolis:void_ingot")

  event.replaceInput({id: "infinity:infinity_generator"}, "minecraft:furnace",  "lavamotron:thermal_shard")
  event.replaceInput({id: "infinity:infinity_generator"}, "minecraft:iron_ingot", "industrialforegoing:plastic")

  event.replaceInput({id: "bhc:heart_amulet"}, "minecraft:string",  "opolisutilities:leafy_string")

  event.replaceInput({id: "industrialforegoing:bioreactor"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:animal_seperator"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:fluid_collector"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:mob_slaughter_factory"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:plant_gatherer"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:dye_mixer"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:biofuel_generator"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:animal_rancher"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:plant_sower"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:animal_feeder"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:animal_baby_separator"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:sludge_refiner"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:sewer"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:spores_recreator"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:sewage_composter"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:fluid_placer"}, "industrialforegoing:machine_frame_pity", "industrialforegoing:machine_frame_simple")
  event.replaceInput({id: "industrialforegoing:fluid_laser_base"}, "industrialforegoing:machine_frame_advanced", "industrialforegoing:machine_frame_supreme")
  event.replaceInput({id: "industrialforegoingsouls:soul_laser_base"}, "minecraft:sculk_shrieker", "stoneopolis:nether_star_fragment")
  event.replaceInput({id: "industrialforegoingsouls:soul_laser_base"}, "minecraft:sculk_catalyst", "stoneopolis:nether_star_fragment")
  event.replaceInput({id: "industrialforegoing:stasis_chamber"}, "industrialforegoing:machine_frame_advanced", "industrialforegoing:machine_frame_supreme")
  event.replaceInput({id: "industrialforegoing:dissolution_chamber"}, "#forge:gears/diamond", bronze_gear)
  event.replaceInput({id: "industrialforegoing:washing_factory"}, "#forge:gears/diamond", bronze_gear)
  event.replaceInput({id: "industrialforegoing:ore_laser_base"}, "#forge:ores/iron", "industrialforegoing:pink_slime_ingot")


  event.replaceInput({mod: "extendedcrafting"}, "extendedcrafting:black_iron_slate", "extendedcrafting:black_iron_ingot")
  event.replaceInput({id: "extendedcrafting:pedestal"}, "extendedcrafting:black_iron_block", "extendedcrafting:frame")
  event.replaceInput({id: "extendedcrafting:crafting_core"}, "extendedcrafting:elite_component", '#caveopolis:colored_wooden_plank_crafting_tables')
  event.replaceInput({id: "extendedcrafting:crafting_core"}, "extendedcrafting:elite_catalyst", '#caveopolis:colored_wooden_plank_crafting_tables')
  event.replaceInput({id: "extendedcrafting:ender_crafter"}, "minecraft:crafting_table", 'extendedcrafting:basic_catalyst')
  event.replaceInput({id: "extendedcrafting:flux_alternator"}, "minecraft:gold_ingot", 'extendedcrafting:advanced_component')
  event.replaceInput({id: "extendedcrafting:flux_crafter"}, "minecraft:crafting_table", 'extendedcrafting:advanced_catalyst')
  
  event.replaceInput({mod: "functionalstorage"}, "minecraft:iron_nugget", "stoneopolis:void_nugget")
  event.replaceInput({mod: "functionalstorage"}, "minecraft:obsidian", "stoneopolis:void_ingot")
  event.replaceInput({}, "minecraft:crafting_table", "#caveopolis:colored_wooden_plank_crafting_tables")

  //Lava Mo Tron
  lavaMoTron("stoneopolis:lapistone_alloy", 'lavamotron:thermal_shard', 1, 1600, "stoneopolis:thermal_shard")

  function lavaMoTron(inItem, outItem, outCount, duration, id){
    event.custom({
      type: "lavamotron:lavamotron",
      "ingredient": {
          "item": inItem
      },
      "result": outItem,
      "count" : outCount,
      "cookingtime": duration
    }).id(id)
  }

  //Immersive Engineering Custom Recipes
  event.custom({"type":"immersiveengineering:mixer","energy":2000,"fluid":{"amount":250,"tag":"minecraft:lava"},"inputs":[{"item":"minecraft:blaze_powder"}],"result":{"amount":250,"fluid":"stoneopolis:blazing_fluid"}})
  event.custom({"type":"immersiveengineering:crusher","energy":3200,"input":{"item":"stoneopolis:rainbow_color_core"},"result":{"count":1,"item":"stoneopolis:rainbow_dye"},"secondaries":[]}).id("stoneopolis:rainbow_dye")
  event.custom({"type":"immersiveengineering:blueprint","category":"components","inputs":[{"base_ingredient":{"tag":"forge:ingots/iron"},"count":2},{"tag":"forge:ingots/copper"},{"item":"stoneopolis:lapistone_alloy"}],"result":{"item":"immersiveengineering:component_iron"}}).id('immersiveengineering:blueprint/component_iron')
  event.custom({"type":"immersiveengineering:blueprint","category":"components","inputs":[{"base_ingredient":{"tag":"forge:ingots/steel"},"count":2},{"tag":"forge:ingots/copper"},{"item":"stoneopolis:lapistone_alloy"}],"result":{"item":"immersiveengineering:component_steel"}}).id('immersiveengineering:blueprint/component_steel')
  event.custom({"type":"immersiveengineering:blueprint","category":"components","inputs":[{"base_ingredient":{"tag":"caveopolis:bright_items"},"count":2}, {"tag":"forge:glass"},{"base_ingredient":[{"item":"minecraft:paper"},{"item":"minecraft:bamboo"}],"count":3},{"tag":"forge:ingots/copper"}],"result":{"count":3,"item":"immersiveengineering:light_bulb"}}).id('immersiveengineering:blueprint/light_bulb')
  event.custom({"type":"immersiveengineering:blueprint","category":"components","inputs":[{"base_ingredient":{"item":"stoneopolis:lapistone_alloy"},"count":1},{"item":"stoneopolis:void_ingot"},{"tag":"minecraft:coals"}],"result":{"item":"stoneopolis:void_iron_ingot"}}).id('stoneopolis:void_iron_ingot_blueprint')
  event.custom({"type":"immersiveengineering:blueprint","category":"components","inputs":[{"base_ingredient":{"item":"minecraft:lapis_lazuli"},"count":1},{"item":"minecraft:redstone"},{"tag":"minecraft:coals"}],"result":{"item":"stoneopolis:lapistone_alloy"}}).id('stoneopolis:lapistone_alloy_blueprint')

  alloyRecipes("stoneopolis:empty_budding_stone", 1, "minecraft:water_bucket", 1, "geode_plus:budding_lapis", 1, "stoneopolis:budding_lapis")
  alloyRecipesComplex("stoneopolis:empty_budding_stone", 1, Item.of('morebuckets:copper_bucket', '{Amount:1000,FluidName:"minecraft:water"}').strongNBT(), "geode_plus:budding_lapis", 1, "stoneopolis:budding_lapis_1")
  alloyRecipesComplex("stoneopolis:empty_budding_stone", 1, Item.of('morebuckets:tin_bucket', '{Amount:1000,FluidName:"minecraft:water"}').strongNBT(), "geode_plus:budding_lapis", 1, "stoneopolis:budding_lapis_2")
  alloyRecipesComplex("stoneopolis:empty_budding_stone", 1, Item.of('morebuckets:bronze_bucket', '{Amount:1000,FluidName:"minecraft:water"}').strongNBT(), "geode_plus:budding_lapis", 1, "stoneopolis:budding_lapis_3")
  alloyRecipes("minecraft:redstone", 1, "minecraft:lapis_lazuli", 1, "stoneopolis:lapistone_alloy", 1, "stoneopolis:lapistone_alloy_recipe")
  alloyRecipes("stoneopolis:void_nugget", 1, "stoneopolis:lapistone_nugget", 1, "stoneopolis:void_iron_nugget", 1, "stoneopolis:void_iron_alloy")
  alloyRecipes("minecraft:stone", 1, "stoneopolis:void_chunk", 1, "stoneopolis:void_stone", 1, "stoneopolis:void_stone_stone")
  alloyRecipes("minecraft:cobblestone", 1, "stoneopolis:void_chunk", 1, "stoneopolis:void_stone", 1, "stoneopolis:void_stone_cobblestone")

  function alloyRecipes(inItem1, inItem1Count, inItem2, inItem2Count, outItem, outItemCount, id) {
    event.custom({
        type:"immersiveengineering:alloy",
        input0:{"item":inItem1, "count": inItem1Count},
        input1:{"item":inItem2, "count": inItem2Count},
        result:{"base_ingredient":{"item":outItem},"count":outItemCount},"time":200
    }).id(id)
  }
  

  function alloyRecipesComplex(inItem1, inItem1Count, inItem2, outItem, outItemCount, id) {
    event.custom({
        type:"immersiveengineering:alloy",
        input0:{"item":inItem1, "count": inItem1Count},
        input1: inItem2,
        result:{"base_ingredient":{"item":outItem},"count":outItemCount},"time":200
    }).id(id)
  }

  //Void Metals    
    function voidIngots(material) {
      event.shaped(`stoneopolis:void_${material}_ingot`, ['NNN', 'NNN', 'NNN'], {N: `stoneopolis:void_${material}_nugget`}).id(`stoneopolis:void_${material}_ingot`)
      event.shapeless(Item.of (`stoneopolis:void_${material}_nugget`, 9), [`stoneopolis:void_${material}_ingot`]).id(`stoneopolis:void_${material}_nugget`)
  }

  voidIngots('iron')
  voidIngots('copper')
  voidIngots('gold')
  voidIngots('lead')
  voidIngots('tin')

  //Leaves to Dye 


  function leavesToDye(color) {
    event.shaped(`minecraft:${color}_dye`, ['LLL', 'LLL', 'LLL'], {L: `caveopolis:${color}_colored_leaves`}).id(`stoneopolis:dye_from_${color}_leaves`)
  }

  leavesToDye('red')
  leavesToDye('yellow')
  leavesToDye('green')
  leavesToDye('brown')
  leavesToDye('blue')
  leavesToDye('purple')
  leavesToDye('cyan')
  leavesToDye('light_gray')
  leavesToDye('gray')
  leavesToDye('pink')
  leavesToDye('lime')
  leavesToDye('light_blue')
  leavesToDye('magenta')
  leavesToDye('orange')
  leavesToDye('white')
  leavesToDye('black')


  //Remove Recipes
  event.remove({id: "minecraft:coarse_dirt"})
  event.remove({id: "hostilenetworks:living_matter/overworld_to_nether"})  
  event.remove({id: "hostilenetworks:living_matter/nether_to_end"})  
  event.remove({id: "minecraft:gold_ingot_from_blasting_deepslate_gold_ore"})  
  event.remove({id: "minecraft:gold_ingot_from_smelting_deepslate_gold_ore"})  
  event.remove({id: "ae2:blasting/silicon_from_certus_quartz_dust"})  
  event.remove({id: "immersiveengineering:crafting/component_iron"})
  event.remove({id: "immersiveengineering:crafting/component_steel"})
  event.remove({id: "minecraft:crafting_table"})    
  event.remove({id: "strainers:dirt"})    
  event.remove({type: "lavamotron:lavamotron"})  
  event.remove({type: "industrialforgoing:netherstar_generator"})  
  event.remove({type: "opolisutilities:resource_generator"})  
  event.remove({input: "#alltheores:ore_hammers"})  
  event.remove({input: "immersiveengineering:hammer"})  
  event.remove({id: "immersiveengineering:crafting/stick_aluminum"})  
  event.remove({id: "immersiveengineering:crafting/stick_steel"})  
  event.remove({id: "industrialforegoing:diamond_gear"})  
  event.remove({id: "industrialforegoing:iron_gear"})  
  event.remove({id: "industrialforegoing:gold_gear"})  
  event.remove({output: "#forge:gears", input: iron_nugget})  
  event.remove({id: "industrialforegoing:fluid_extractor/default"})  
  event.remove({id: "industrialforegoing:fluid_extractor/oak"})  
  event.remove({id: "industrialforegoing:fluid_extractor/acacia"})  
  event.remove({id: "industrialforegoing:fluid_extractor/birch"})  
  event.remove({id: "industrialforegoing:fluid_extractor/dark_oak"})  
  event.remove({id: "industrialforegoing:fluid_extractor/jungle"})  
  event.remove({id: "industrialforegoing:fluid_extractor/spruce"})  
  event.remove({id: "minecraft:netherite_scrap_from_blasting"})  
  event.remove({id: "minecraft:netherite_scrap"})  
  event.remove({id: "industrialforegoing:block_breaker"})  
  event.remove({id: "industrialforegoing:block_placer"})  
  event.remove({id: "industrialforegoing:water_condensator"})  
  event.remove({id: "mining_dimension:teleporter"})  
  event.remove({id: "/industrialforegoing:laser_drill_ore/*/"})  
  event.remove({id: "minecraft:netherite_ingot"})  
  event.remove({id: "extendedcrafting:black_iron_ingot"})  
  event.remove({id: 'minecraft:crafting_table'})
  event.remove({id: 'strainers:nether_wart_from_straining_netherrack_in_strainers_eroding_water'})
  event.remove({output: [
    'functionalstorage:oak_1', 
    'functionalstorage:spruce_1', 
    'functionalstorage:birch_1', 
    'functionalstorage:jungle_1', 
    'functionalstorage:acacia_1', 
    'functionalstorage:dark_oak_1', 
    'functionalstorage:crimson_1', 
    'functionalstorage:warped_1', 
    'functionalstorage:mangrove_1', 
    'functionalstorage:crimson_2', 
    'functionalstorage:dark_oak_2', 
    'functionalstorage:jungle_2', 
    'functionalstorage:acacia_2', 
    'functionalstorage:birch_2', 
    'functionalstorage:spruce_2', 
    'functionalstorage:oak_2', 
    'functionalstorage:cherry_1', 
    'functionalstorage:warped_2', 
    'functionalstorage:mangrove_2', 
    'functionalstorage:cherry_2', 
    'functionalstorage:oak_4', 
    'functionalstorage:spruce_4', 
    'functionalstorage:birch_4', 
    'functionalstorage:jungle_4', 
    'functionalstorage:acacia_4', 
    'functionalstorage:cherry_4', 
    'functionalstorage:mangrove_4',
    'functionalstorage:warped_4', 
    'functionalstorage:crimson_4', 
    'functionalstorage:dark_oak_4',
    'functionalstorage:controller_extension', 
    'functionalstorage:simple_compacting_drawer', 
    'functionalstorage:storage_controller', 
    'functionalstorage:compacting_drawer',
    'industrialforegoing:mycelial_meatallurgic', 
    'industrialforegoing:mycelial_crimed', 
    'industrialforegoing:mycelial_rocket', 
    'industrialforegoing:mycelial_death', 
    'industrialforegoing:mycelial_netherstar', 
    'industrialforegoing:mycelial_pink', 
    'industrialforegoing:mycelial_magma', 
    'industrialforegoing:mycelial_halitosis', 
    'industrialforegoing:mycelial_frosty', 
    'industrialforegoing:mycelial_explosive', 
    'industrialforegoing:mycelial_ender', 
    'industrialforegoing:mycelial_disenchantment', 
    'industrialforegoing:mycelial_potion', 
    'industrialforegoing:mycelial_culinary', 
    'industrialforegoing:mycelial_slimey', 
    'industrialforegoing:mycelial_furnace', 
    'industrialforegoing:biofuel_generator', 
    'industrialforegoing:pitiful_generator',
    'industrialforegoing:mycelial_reactor',
    'industrialforegoing:bioreactor',
    "dimpaintings:overworld_painting",
    "dimpaintings:nether_painting"
  ]
  
})





    










    





    //Remove



    //Deep

  









})

